<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="关于DNS和Apache － Apache 2.2 中文手册 [金步国作品集]">
<title>关于DNS和Apache － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body id="manual-page">
<div id="page-header"><p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="../index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>关于DNS和Apache</h1>


    <p>本文档的涵义用一句话总结就是：不要让Apache在分析配置文件的时候使用到DNS解析。如果Apache在分析配置文件时用到了DNS解析，您的服务器就会发生可靠性的问题(也可能根本无法启动)，或者遭致拒绝(偷窃)服务攻击(包括用户可以从其他用户那里偷窃点击)。</p>
  </div>
	<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="example" id="example">一个简单示例</a></h2>


    <div class="example"><p><code>
      &lt;VirtualHost www.abc.dom&gt; <br />
      ServerAdmin webgirl@abc.dom <br />
      DocumentRoot /www/abc <br />
      &lt;/VirtualHost&gt;
    </code></p></div>

    <p>为了让Apache功能正常，一个虚拟主机绝对需要以下两部分的信息：<code class="directive"><a href="../mod/core.html#servername">ServerName</a></code>和与该服务器绑定的至少一个IP地址。上述示例没有包括IP地址，于是Apache必须要使用DNS解析来查询<code>www.abc.dom</code>的地址。如果在某些不可预料的情况下，当您的服务器解析配置文件时没有得到DNS的支持，那么这个虚拟主机将<strong>不会被配置</strong>。它将不会对任何请求作出反应。(在Apache1.2之前的版本，服务器甚至无法启动)。</p>

    <p>假设<code>www.abc.dom</code>的IP地址是10.0.0.1，那么考虑以下这个配置片断：</p>

    <div class="example"><p><code>
      &lt;VirtualHost 10.0.0.1&gt; <br />
      ServerAdmin webgirl@abc.dom <br />
      DocumentRoot /www/abc <br />
      &lt;/VirtualHost&gt;
    </code></p></div>

    <p>现在Apache需要DNS对这个虚拟主机进行反向域名解析来确定其<code>ServerName</code>。如果反向解析失败，那么将导致这个虚拟主机功能丧失(在Apache的1.2版本之前，服务器将不能启动)。如果虚拟主机是基于域名的，它将完全不能使用，但如果它是基于IP的，那么它将很有可能工作。然而，如果Apache不得不为一个已经包含了服务器域名的服务器产生一个完整的URL，那么它将可能产生一个无效的URL。</p>

    <p>以下是一个可以避免上述两个问题的配置片断：</p>

    <div class="example"><p><code>
      &lt;VirtualHost 10.0.0.1&gt; <br />
      ServerName www.abc.dom <br />
      ServerAdmin webgirl@abc.dom <br />
      DocumentRoot /www/abc <br />
      &lt;/VirtualHost&gt;
    </code></p></div>
  </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="denial" id="denial">拒绝服务</a></h2>


    <p>拒绝服务主要由(至少)两种形式导致。如果您在运行Apache1.2以前的版本，在上述两种情况下，如果您的任何一个虚拟主机的DNS解析失败，您都会无法启动服务。在一些情况下，DNS解析甚至不在您的控制范围之内。比如说，如果<code>abc.dom</code>是您的一个客户，而且他们自己控制着DNS。那么仅仅是因为他们删除了<code>www.abc.dom</code>这个记录，都会导致您1.2版本以前的Apache无法启动。</p>

    <p>另外一种形式就更隐蔽了。比如说下面这个配置片断：</p>

    <div class="example"><p><code>
      &lt;VirtualHost www.abc.dom&gt; <br />
      &nbsp;&nbsp;ServerAdmin webgirl@abc.dom <br />
      &nbsp;&nbsp;DocumentRoot /www/abc <br />
      &lt;/VirtualHost&gt; <br />
      <br />
      &lt;VirtualHost www.def.dom&gt; <br />
      &nbsp;&nbsp;ServerAdmin webguy@def.dom <br />
      &nbsp;&nbsp;DocumentRoot /www/def <br />
      &lt;/VirtualHost&gt;
    </code></p></div>

    <p>假设您已经为<code>www.abc.dom</code>设定了10.0.0.1、为<code>www.def.dom</code>设定了10.0.0.2。更进一步，假设<code>def.dom</code>自己控制DNS。在这种配置下，<code>def.dom</code>可以将所有指向<code>abc.dom</code>的流量据为己。为了达到这个目的，他们只需把<code>www.def.dom</code>的地址解析设置成10.0.0.1就可以了。因为他们控制着自己的DNS服务，所以您无法阻止他们把<code>www.def.dom</code>这个记录指向任何一个IP地址。</p>

    <p>然后，所有向10.0.0.1发出的请求(包括用户所有类似<code>http://www.abc.dom/whatever</code>的URL)都将会被<code>def.dom</code>这个虚拟主机所接收。为了更好的理解这一切是怎样发生的，您需要一个关于Apache是怎样将进入的请求分配给它的虚拟主机的深入说明。您可以在这里找到<a href="../vhosts/details.html">一个完整的文档</a>。</p>
  </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="main" id="main">"主服务器"地址</a></h2>


    <p>在Apache1.1中，<a href="../vhosts/name-based.html">基于域名的虚拟主机支持</a>需要Apache知道运行<code class="program"><a href="../programs/httpd.html">httpd</a></code>的主机的IP地址。可以用全局变量<code class="directive"><a href="../mod/core.html#servername">ServerName</a></code>(如果存在)或者调用C函数<code>gethostname</code>(与在命令行模式下键入"hostname"得到的返回值一样)。接着它就会利用DNS来查找这个地址。目前还没有办法避免这样的查找。</p>

    <p>如果您担心这样的查找会因为您的DNS服务器没有启动而遭到失败的结果，您就可以在<code>/etc/hosts</code>中插入一条记录来确定主机名(此文件中应该已经存在这条记录了，否则您的机器可能无法正常启动)。然后，要确认您的机器已经配置为当DNS解析失败的情况下会使用<code>/etc/hosts</code> ，根据所使用的操作系统不同，您可能需要在<code>/etc/resolv.conf</code>或<code>/etc/nsswitch.conf</code>两个文件中选择一个进行编辑。</p>

    <p>如果您的服务器不必因为其他理由而使用DNS，您也许不必在把<code>HOSTRESORDER</code>环境变量设为"local"的情况下运行Apache。这取决于您所使用的操作系统和解析库。如果您没有使用<code class="module"><a href="../mod/mod_env.html">mod_env</a></code>来控制环境变量，它还将影响到CGI。强烈建议您查看操作系统附带的man帮助或FAQ。</p>
  </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="tips" id="tips">避免这些问题的小技巧</a></h2>


    <ul>
      <li>在<code class="directive"><a href="../mod/core.html#virtualhost">VirtualHost</a></code>中使用IP地址</li>

      <li>在<code class="directive"><a href="../mod/mpm_common.html#listen">Listen</a></code>中使用IP地址</li>

      <li>确保所有的虚拟主机拥有显式的<code class="directive"><a href="../mod/core.html#servername">ServerName</a></code>定义</li>

      <li>创建一个不包含任何页面的<code>&lt;VirtualHost _default_:*&gt;</code>服务器</li>
    </ul>
  </div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="appendix" id="appendix">附录：进一步的提示</a></h2>


    <p>涉及到DNS的情况都很让人很不舒服。在Apache1.2中，我们努力想让服务器在DNS解析失败的情况下至少保持能够启动，但我们没能做到。在当今重编号成了必须的Internet上面，在配置文件中显式的写明IP地址已经成为不合时宜的行为了。</p>

    <p>上述盗窃攻击的解决办法是在一个正向DNS查询后再进行一个逆向DNS解析并将两个结果进行比较。如果不同，就禁用相应的虚拟主机。这个方法需要一个正确配置了的逆向域名解析服务器(因为FTP服务器和TCP封装进行的"双重逆向"DNS处理的普遍应用，这已为大部分管理员所熟知了)。</p>

    <p>在某些情况下，如果没有使用IP地址而DNS解析又失败了，那么正常启动一个基于域名的虚拟主机看来是不可能的。一些诸如禁用部分配置文件这样的权宜之计会带来比根本不能启动更遭的不可预测的结果。</p>

    <p>随着HTTP/1.1的部署以及浏览器和代理服务器开始支持<code>Host</code>头，我们完全避免使用基于IP的虚拟主机也逐渐成为可能。这种状况下，web服务器也不必在配置时进行DNS的查询。但在1997年3月，这些特性的采用还没有广泛到可以在重要的web服务器应用的地步。</p>
  </div></div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
